// =========  Start of Button.h generated code ==========
#ifndef BUTTON_H
#define BUTTON_H

//  Button.h from Button by pfodGUIdesigner V1.0.4192
/*
  (c)2022 Forward Computing and Control Pty. Ltd.
  NSW Australia, www.forward.com.au
  This code is not warranted to be fit for any purpose. You may only use it at your own risk.
  This code may be freely used for both private and commercial use
  Provided this copyright is maintained.
*/

#include <pfodParser.h>
#include <pfodDwgs.h>
#include <pfodDrawing.h>

typedef std::function<void()> ButtonCallback;

class Button : public pfodDrawing {
  public:
    Button(pfodParser* parserPtr, pfodDwgs* dwgsPtr);
    bool sendDwg(); // returns is dwg sent else false i.e. not this dwg's loadCmd
    bool processDwgCmds(); // return true if handled else false
    void setText(const char* text);
    void setTextColor(int color);
    void setCmdCallback(ButtonCallback cb);
    void setVisible(bool _isVisible); // flag true for visible false for hidden

  private:
    void sendFullDrawing(long dwgIdx);
    void sendUpdate();
    void drawDwg0();
    void updateDwg();
    bool forceReload;
    void printDwgCmdReceived(Print* outPtr);
    pfodAutoIdx _update_idx_9;
    pfodAutoIdx _idx_1;
    pfodAutoIdx _idx_2;
    pfodAutoCmd _touchZone_cmd_2;
    char buttonText[15];
    int textColor = 0; // black
    ButtonCallback buttonCallback; 
    bool isVisible;
};
#endif
// =========  End of Button.h generated code ==========
