// =========  Start of Dwg_1.cpp generated code ==========
//  Dwg_1.cpp from Dwg_1 by pfodGUIdesigner V1.0.4192
/*
  (c)2022 Forward Computing and Control Pty. Ltd.
  NSW Australia, www.forward.com.au
  This code is not warranted to be fit for any purpose. You may only use it at your own risk.
  This code may be freely used for both private and commercial use
  Provided this copyright is maintained.
*/

#include "Dwg_1.h"

const float hotWaterkWatts = 3.5;

void Dwg_1::updateDwg_1(float _threePhaseWatts, float _solarHotHeaterWatts, bool _hotWaterAuto) {
  threePhaseWatts = _threePhaseWatts;
  solarHotHeaterWatts = _solarHotHeaterWatts;
  hotWaterAuto = _hotWaterAuto;
  float displayW = threePhaseWatts;
  if (hotWaterAuto) {
    // add solar/ 1000.0 ;
    displayW -= solarHotHeaterWatts; // export -ve
  }
  displaykW = -displayW / 1000.0; // here +ve for export
  //  Serial.print(displayWatts);Serial.print("  ");Serial.println(displaykW);
  if (displaykW >= 0) {
    ExpFlag = true;
  } else {
    ExpFlag = false;
  }
  // limit value to 10kW max and hot water always +ve <10kW
  if (solarHotHeaterWatts > 10000) {
    solarHotHeaterWatts = 10000;
  }
  if (solarHotHeaterWatts < 100) {
    solarHotHeaterWatts = 0; // zero out noise
  }
  if (threePhaseWatts < -10000) {
    threePhaseWatts = -10000;
  }
  if (threePhaseWatts > 10000) {
    threePhaseWatts = 10000;
  }
  if ((threePhaseWatts - solarHotHeaterWatts) < -10000) {
    solarHotHeaterWatts = -(-10000 - threePhaseWatts);
  }
}

Dwg_1::Dwg_1(pfodParser * parserPtr, pfodDwgs * dwgsPtr) : pfodDrawing(parserPtr, dwgsPtr) {
  forceReload = true; // force reload on reboot, e.g. reprogrammed
  displaykW = 0.0;
  hotWaterAuto = true;
  ExpFlag = false; // export
}

bool Dwg_1::processDwgCmds() { // return true if handled else false
  byte dwgCmd = parserPtr->parseDwgCmd(); // dwgCmd is '\0' if this is NOT a dwg cmd
  if (!dwgCmd) {
    return false; // not dwg cmd not handled
  }
  return false; // not handled
}


void Dwg_1::drawDwg0() {
  dwgsPtr->circle().color(0).offset(0.00, 0.00).radius(15.00).send();
  dwgsPtr->index().idx(_update_idx_2).send();
  dwgsPtr->index().idx(_update_idx_3).send();
  dwgsPtr->index().idx(_update_idx_4).send();
  dwgsPtr->index().idx(_update_idx_5).send();
  dwgsPtr->index().idx(_update_idx_6).send();
  dwgsPtr->index().idx(_update_idx_7).send();
  dwgsPtr->index().idx(_update_idx_8).send(); // for hotwater pie if on
  dwgsPtr->index().idx(_update_idx_9).send(); // for hotwater pie if on
}

void Dwg_1::updateDwg() {
//   Serial.print(" threePhaseWatts:"); Serial.print(threePhaseWatts); 
//   Serial.print(" solarHW_kWhrs:"); Serial.print(solarHW_kWhrs); 
//  Serial.print(" solarHotHeaterWatts:"); Serial.print(solarHotHeaterWatts); 
//  Serial.print(" displaykW:"); Serial.print(displaykW);
//  Serial.println(); 

  float displayAngleScale = 180.0 / 10000.0;
  if (ExpFlag) { // export
    dwgsPtr->unhide().idx(_update_idx_2).send();
    dwgsPtr->unhide().idx(_update_idx_3).send();
    dwgsPtr->unhide().idx(_update_idx_4).send();
    dwgsPtr->hide().idx(_update_idx_5).send();
    dwgsPtr->hide().idx(_update_idx_6).send();
    dwgsPtr->hide().idx(_update_idx_7).send();
    if (threePhaseWatts < -2500) {
      dwgsPtr->arc().idx(_update_idx_2).color(10).offset(0.00, 0.00).radius(15.00).start(180.00).angle(threePhaseWatts * displayAngleScale).filled().send();
    } else {
      dwgsPtr->arc().idx(_update_idx_2).color(11).offset(0.00, 0.00).radius(15.00).start(180.00).angle(threePhaseWatts * displayAngleScale).filled().send();
    }
    dwgsPtr->arc().idx(_update_idx_3).color(0).offset(0.00, 0.00).radius(15.00).start(180.00).angle(threePhaseWatts * displayAngleScale).send();
    dwgsPtr->label().idx(_update_idx_4).color(2).offset(0.00, -18.00).text("Export ").fontSize(6).bold().center().value(displaykW).decimals(1).units("kW").send();
  } else { // import
    dwgsPtr->hide().idx(_update_idx_2).send();
    dwgsPtr->hide().idx(_update_idx_3).send();
    dwgsPtr->hide().idx(_update_idx_4).send();
    dwgsPtr->unhide().idx(_update_idx_5).send();
    dwgsPtr->unhide().idx(_update_idx_6).send();
    dwgsPtr->unhide().idx(_update_idx_7).send();
    dwgsPtr->label().idx(_update_idx_5).color(9).offset(0.00, 18.00).text("Import ").fontSize(6).bold().center().value(-displaykW).decimals(1).units("kW").send();
    dwgsPtr->arc().idx(_update_idx_6).color(9).offset(0.00, 0.00).radius(15.00).start(180.00).angle(threePhaseWatts * displayAngleScale).filled().send();
    dwgsPtr->arc().idx(_update_idx_7).color(0).offset(0.00, 0.00).radius(15.00).start(180.00).angle(threePhaseWatts * displayAngleScale).send();
  }
  if (solarHotHeaterWatts > 0) {
    dwgsPtr->unhide().idx(_update_idx_8).send();
    dwgsPtr->unhide().idx(_update_idx_9).send();
    dwgsPtr->arc().idx(_update_idx_8).color(208).offset(0.00, 0.00).radius(15.00).start(180 + (threePhaseWatts * displayAngleScale)).angle(-solarHotHeaterWatts * displayAngleScale).filled().send();
    dwgsPtr->arc().idx(_update_idx_9).color(0).offset(0.00, 0.00).radius(15.00).start(180 + (threePhaseWatts * displayAngleScale)).angle(-solarHotHeaterWatts * displayAngleScale).send();
  } else {
    dwgsPtr->hide().idx(_update_idx_8).send();
    dwgsPtr->hide().idx(_update_idx_9).send();
  }
}

bool Dwg_1::sendDwg() {
  if (!parserPtr->cmdEquals(*this)) {
    return false; // not this dwg's loadCmd
  }  // else
  //  // ======== begin debugging
  //  Serial.print(" sendDwg() cmd "); Serial.print((char*)parserPtr->getCmd());
  //  if (parserPtr->isRefresh()) {
  //    Serial.print(" isRefresh");
  //  }
  //  byte* argPtr = parserPtr->getFirstArg();
  //  if (*argPtr) {
  //    Serial.print("  args: ");
  //    while (*argPtr) {
  //      Serial.print("  "); Serial.print((char*)argPtr);
  //      argPtr = parserPtr->getNextArg(argPtr);
  //    }
  //  }
  //  Serial.print("\n");
  //  //======= end debugging =======
  if (parserPtr->isRefresh() && !forceReload) { // refresh and not forceReload just send update
    sendUpdate();
  } else {
    forceReload = false; //
    long pfodLongRtn = 0;
    uint8_t* pfodFirstArg = parserPtr->getFirstArg(); // may point to \0 if no arguments in this msg.
    parserPtr->parseLong(pfodFirstArg, &pfodLongRtn); // parse first arg as a long
    sendFullDrawing(pfodLongRtn);
  }
  return true;
}

void Dwg_1::sendFullDrawing(long dwgIdx) {
  if (dwgIdx == 0) {
    dwgsPtr->start(50, 50, dwgsPtr->WHITE, true);  // the dwg size 50x50 and color (WHITE) are ignored when this drawing is inserted in the main dwg
    //true means more to come
    parserPtr->sendRefreshAndVersion(0); //need to set a version number for image refresh to work!!
    drawDwg0(); //
    dwgsPtr->end();

    // if drawing msg is >1023 split it in to two or more parts and add extra else if (dwgIdx == .. ) blocks here

  } else if (dwgIdx == 1) {
    dwgsPtr->startUpdate(false);  // always send update last so this is the last msg => false
    updateDwg(); // update with current state, // defined in display.cpp
    dwgsPtr->end();

  } else {
    parserPtr->print(F("{}")); // always return somthing
  }
}

void Dwg_1::sendUpdate() {
  dwgsPtr->startUpdate();  // dwg refresh updates must be <1024 bytes, i.e. can only be 1 msg
  updateDwg();
  dwgsPtr->end();
}

void Dwg_1::printDwgCmdReceived(Print * outPtr) {
  if (!outPtr) {
    return;
  }
  outPtr->print("     touchZone cmd "); outPtr->print((const char*)parserPtr->getDwgCmd()); outPtr->print(" at ");
  outPtr->print("("); outPtr->print(parserPtr->getTouchedX()); outPtr->print(",");
  outPtr->print(parserPtr->getTouchedY()); outPtr->print(") ");
  if (parserPtr->isTouch()) {
    outPtr->print("touch type:TOUCHED");
  }
  outPtr->println();
  if (*parserPtr->getEditedText()) { // first char not '\0'
    outPtr->print("     Edited text '"); outPtr->print((const char*)parserPtr->getEditedText()); outPtr->println("'");
  }
}
// =========  End of Dwg_1.cpp generated code ==========
