// =========  Start of Label.cpp generated code ==========
//  Label.cpp from Label by pfodGUIdesigner V1.0.4192
/*
  (c)2022 Forward Computing and Control Pty. Ltd.
  NSW Australia, www.forward.com.au
  This code is not warranted to be fit for any purpose. You may only use it at your own risk.
  This code may be freely used for both private and commercial use
  Provided this copyright is maintained.
*/

#include "Label.h"
#include <SafeString.h>

void Label::setTextSize(int _size) {
  size = _size;
}

void Label::setText(const char* _text) {
  cSFA(sfText,text);  
  sfText.clear();
  sfText.readFrom(_text); // reads at most 10chars
  
}
void Label::setTextColor(int color) {
  if (color < 0) {
    color = 0;
  }
  if (color > 255) {
    color = 255;
  }
  textColor = color;
}

Label::Label(pfodParser* parserPtr, pfodDwgs* dwgsPtr) : pfodDrawing(parserPtr, dwgsPtr) {
  forceReload = true; // force reload on reboot, e.g. reprogrammed
  text[0]='\0';
}

bool Label::processDwgCmds() { // return true if handled else false
  byte dwgCmd = parserPtr->parseDwgCmd(); // dwgCmd is '\0' if this is NOT a dwg cmd
  if (!dwgCmd) {
    return false; // not dwg cmd not handled
  }
  return false; // not handled
}


void Label::drawDwg0() {
  dwgsPtr->index().idx(_update_idx_13).send();
}

void Label::updateDwg() {
  dwgsPtr->label().idx(_update_idx_13).color(textColor).offset(0.00,0.00).text(text).fontSize(size).bold().center().send();
}

bool Label::sendDwg() {
  if (!parserPtr->cmdEquals(*this)) {
    return false; // not this dwg's loadCmd
  }  // else
//  // ======== begin debugging
//  Serial.print(" sendDwg() cmd "); Serial.print((char*)parserPtr->getCmd());
//  if (parserPtr->isRefresh()) {
//    Serial.print(" isRefresh");
//  }
//  byte* argPtr = parserPtr->getFirstArg();
//  if (*argPtr) {
//    Serial.print("  args: ");
//    while (*argPtr) {
//      Serial.print("  "); Serial.print((char*)argPtr);
//      argPtr = parserPtr->getNextArg(argPtr);
//    }
//  }
//  Serial.print("\n");
//  //======= end debugging =======
  if (parserPtr->isRefresh() && !forceReload) { // refresh and not forceReload just send update
    sendUpdate();
  } else {
    forceReload = false; //
    long pfodLongRtn = 0;
    uint8_t* pfodFirstArg = parserPtr->getFirstArg(); // may point to \0 if no arguments in this msg.
    parserPtr->parseLong(pfodFirstArg, &pfodLongRtn); // parse first arg as a long
    sendFullDrawing(pfodLongRtn);
  }
  return true;
}

void Label::sendFullDrawing(long dwgIdx) {
  if (dwgIdx == 0) {
    dwgsPtr->start(50, 50, dwgsPtr->WHITE, true);  // the dwg size 50x50 and color (WHITE) are ignored when this drawing is inserted in the main dwg
    //true means more to come
    parserPtr->sendRefreshAndVersion(0); //need to set a version number for image refresh to work!!
    drawDwg0(); //
    dwgsPtr->end();
    
    // if drawing msg is >1023 split it in to two or more parts and add extra else if (dwgIdx == .. ) blocks here
    
  } else if (dwgIdx == 1) {
    dwgsPtr->startUpdate(false);  // always send update last so this is the last msg => false
    updateDwg(); // update with current state, // defined in display.cpp
    dwgsPtr->end();
    
  } else {
    parserPtr->print(F("{}")); // always return somthing
  }
}

void Label::sendUpdate() {
  dwgsPtr->startUpdate();  // dwg refresh updates must be <1024 bytes, i.e. can only be 1 msg
  updateDwg();
  dwgsPtr->end();
}

void Label::printDwgCmdReceived(Print *outPtr) {
  if (!outPtr) {
    return;
  }
  outPtr->print("     touchZone cmd "); outPtr->print((const char*)parserPtr->getDwgCmd()); outPtr->print(" at ");
  outPtr->print("("); outPtr->print(parserPtr->getTouchedX()); outPtr->print(",");
  outPtr->print(parserPtr->getTouchedY()); outPtr->print(") ");
  if (parserPtr->isTouch()) {
    outPtr->print("touch type:TOUCHED");
  }
  outPtr->println();
  if (*parserPtr->getEditedText()) { // first char not '\0'
    outPtr->print("     Edited text '"); outPtr->print((const char*)parserPtr->getEditedText()); outPtr->println("'");
  }
}
// =========  End of Label.cpp generated code ==========
